#ifndef _STUDENTINCOURSE_CPP
#define _STUDENTINCOURSE_CPP

#include <string>
#include <fstream>
#include "StudentInCourse.h"

using namespace std;

//-----------------------------------------------------------------
//                             
//-----------------------------------------------------------------
void StudentInCourse::setIdNumCCode( Student& aStudent,
                                     string aCCode,
                                     Course crsArr[], int nOfCourses )
{
   crsArr[nOfCourses].setCode( aCCode.c_str() );
   int cPos( 0 );
   while ( strcmp(crsArr[nOfCourses].getCode(),
                  crsArr[cPos].getCode())!=0 )
      ++cPos;
   if ( cPos == nOfCourses )
     throw StudentInCourseXptn( "StudentInCourse",
                                StudentInCourseXptn::unknownCCode,
                                aCCode.c_str() );
   sicSIdNum = aStudent.getIdNum();
   aStudent.add1Course( crsArr[cPos].getWH() );
   strcpy( sicCCode, aCCode.c_str() );
   crsArr[cPos].add1Student();
} // StudentInCourse::setIdNumCCode

void StudentInCourse::save( ostream& bout ) const
{
   if ( bout.fail() )
      throw StudentInCourseXptn( "save",StudentInCourseXptn::fileNotOpen );
   bout.write( reinterpret_cast<const char*>(&sicSIdNum), sizeof(sicSIdNum) );
                                                          //  
   bout.write( sicCCode, sicCCodeSz );                    //  
   bout.write( reinterpret_cast<const char*>(&sicMark), sizeof(sicMark) );
                                                        //   
   if ( bout.fail() )
      throw StudentInCourseXptn( "save", StudentInCourseXptn::cannotWrite );
} // StudentInCourse::save

void StudentInCourse::display( ostream& tout ) const
{
   tout << sicSIdNum << ' ' << sicCCode << endl;
} // StudentInCourse::display

#endif // _STUDENTINCOURSE_CPP
